//**********************************************************
//
//  Copyright (c) 2000  SeikoEpson Inc
//  All Rights Reserved
//
//  File name : def_api.h
//      
//  Revision  :
//       2000/08/10 C.Nakayama        add api spec
//      
//**********************************************************/
#ifndef _def_api_
#define _def_api_

// define
#define CPU_NO_FETCH                0			// read is instruction execute
#define CPU_FETCH                   16			// read is instruction fetch
#define CPU_VEC_READ                32			// read is vector read

#define EXT_SIGN	                0			// extend sign
#define EXT_ZERO                    0x100		// extend zero

#define DB33_TO_DLL_SET_DB33_FUNC   0x1			//db33 function set up request
#define DB33_TO_DLL_INITIALIZE      0x2			//initialize request
#define DB33_TO_DLL_CLOSE           0x3			//dll close  request
#define DB33_TO_DLL_RESET           0x4			//dll reset  request
#define DB33_TO_DLL_ESC_BREAK       0x5			//esc break

#define DB33_TO_DLL_READ            0x10		//dll read   request
#define DB33_TO_DLL_WRITE           0x11		//dll write  request
#define DB33_TO_DLL_SIM_IN          0x12		//dll in simulation or out simulation
#define DB33_TO_DLL_BLOCK_R_W       0x13		//dll in blodk read/write

#define DB33_TO_DLL_SLP_HLT         0x100		//sleep/halt request
#define DB33_TO_DLL_SET_PSR         0x101		//PSR set request
#define DB33_TO_DLL_NMI_ACK         0x103		//NMI ack request

#define DB33_TO_DLL_FILL            0x200		//fill ack request
#define DB33_TO_DLL_MOVE            0x201		//move ack request

#define DB33_TO_DLL_READ_CLOCK      0x301		//read clock request
#define DB33_TO_DLL_WRITE_CLOCK     0x302		//write clock request
#define DB33_TO_DLL_READ_REG        0x303		//read register request
#define DB33_TO_DLL_WRITE_REG       0x304		//write register request

#define DB33_TO_DLL_CPU_EXE         0x400		//execute cpu request
#define DB33_TO_DLL_CPU_BREAK       0x401		//break cpu request
#define DB33_TO_DLL_CPU_CONT        0x402		//step execute cpu request
#define DB33_TO_DLL_BREAK_SET       0x403		//break set request
#define DB33_TO_DLL_DATA_BREAK      0x404		//data break set cpu request

#define DB33_TO_DLL_GET_MODE_P      0x500		//get cpu mode request
#define DB33_TO_DLL_GET_CACHE       0x501		//get cache on/off
#define DB33_TO_DLL_GET_WATCH       0x502		//get watch on/off
#define DB33_TO_DLL_GET_LF_LH_WR    0x503		//get write on/off in lh and lf command

#define DB33_TO_DLL_STEP            0x510		//step
#define DB33_TO_DLL_SRC_STEP        0x511		//src step
#define DB33_TO_DLL_GO              0x512		//go
#define DB33_TO_DLL_PC_BREAK_SET    0x520		//pc break set
#define DB33_TO_DLL_DATA_BREAK_SET  0x521		//data break set
#define DB33_TO_DLL_REG_R_W         0x530		//register read/write

#define DLL_TO_DB33_READ            0x1000		//db33 read request
#define DLL_TO_DB33_WRITE           0x1001		//db33 write request
#define DLL_TO_DB33_BLOCK_R_W       0x1002		//db33 block r/w request
#define DLL_TO_DB33_INTERRUPT       0x1003		//db33 interrupt request

#define DLL_TO_DB33_FILL            0x1010		//db33 fill request
#define DLL_TO_DB33_MOVE            0x1011		//db33 move request

#define DLL_TO_DB33_KEY_BREAK       0x1100		//db33 key break check request

#define DLL_TO_DB33_CURSOR          0x2000		//db33 cousor change
#define DLL_TO_DB33_WM_MIN          0x2001		//db33 minimum window
#define DLL_TO_DB33_WM_RESTORE      0x2002		//db33 normal window

//structure
struct InterruptInfo{							//interrupt informaion
	unsigned long ulType;
	unsigned long ulVector;
	unsigned long ulLevel;
	unsigned long ulPSR;
};

#endif