/*
 * Created on 2004/08/17
 *
 */
package jp.co.epson.ide.eclipse.gnu33.build;

import java.util.List;
import java.util.Map;


/**
 * Interface for a BuildSetting category.
 * A category represents a node in the tree in BuildSettingsPropertyPage.
 * @author D.Fujimoto
 *
 */
public interface IBuildCategory {

	/**
	 * Returns the tool this category belongs to.
	 */
	public IBuildTool getTool();
	
	/**
	 * Returns the category's name.
	 */
	public String getCategoryName();
	
	/**
	 * Returns the category's ID.
	 */
	public String getCategoryID();
	
	/**
	 * Adds an option to this category.
	 * @param option
	 */
	public void addOption(IBuildOption option);
	
	/**
	 * Returns a List of options in this category.
	 * @return List of IBuildOption
	 */
	public List getOptions();

	/**
	 * Returns the options in this category as a Map.
	 * An option can be retrieved by giving the option's id as the key.
	 * @return Map of IBuildOptions
	 */
	public Map getOptionMap();
	
	
}
