/*
 * Migrated for GNU33 on 2007/01/19 from GNU17(1.0.0)
 */
package jp.co.epson.ide.eclipse.gnu33.cpuinfo;

/**
 * Preference Keys for CPU settings.
 * The keys also qualify for CPU setting file property keys
 * @author D.Fujimoto
 *
 */
public interface ICpuPreferenceConstants {

	// general keys
	String VERSION = "version";
	String CPU_TYPE = "cpuType";
	String CPU_NAME = "cpuName";
	String CPU_DISP_NAME = "cpuDisplayName";
	String MEM_MODEL = "memoryModel";
	String VECTOR_ADDRESS = "vectorAddress";
	String HIGH_LIB = "useHighPrecisionLib";
	
	// lds keys
	String BSS_VMA = "lds.section.bss.vma";
	
	// par area keys
	String PAR_AREA_COUNT = "parAreas";
	String PAR_AREA_TYPE = "AreaType";
	String PAR_AREA_START = "AreaStartAddress";
	String PAR_AREA_SIZE = "AreaSize";
	String PAR_AREA_ACCESS_SIZE = "AreaAccessSize";
	String PAR_AREA_READ_WAIT = "AreaReadWait";
	String PAR_AREA_WRITE_WAIT = "AreaWriteWait";
	String PAR_BIG_ENDIAN = "AreaBigEndian";
	String PAR_AREA_COMMENT = "AreaComment";
	
	// cmd keys
	String DEBUGGER_TYPE = "debugger.type";
	String DEBUG_RAM_ADDR = "debugRamAddr";
	
}
