/*
 * Created on 2006/12/11 
 */
package jp.co.epson.ide.eclipse.gnu33.debug;

import jp.co.epson.ide.eclipse.gnu33.ResourceProvider;
import jp.co.epson.ide.eclipse.gnu33.general.GeneralInfo;
import jp.co.epson.ide.eclipse.gnu33.others.IAddrBitChecker;

/**
 * Checks the vector address bits 
 * @author D.Fujimoto
 *
 */
public class AddrBitChecker implements IAddrBitChecker {

	/**
	 * the error message
	 */
	private String message;
	
	/**
	 * CPU type
	 */
	private int cpuType;
	

	/**
	 * Constructor
	 * Takes a CPU type for checking 
	 * @param cpuType
	 */
	public AddrBitChecker(int cpuType) {
		this.cpuType = cpuType;
	}
	
	/*
	 * (non-Javadoc)
	 * @see jp.co.epson.ide.eclipse.gnu33.others.IAddrBitChecker#check(long)
	 */
	public void check(long addr) {
		message = null;

		// check vector address bit masks
		if (cpuType == GeneralInfo.CPU_STD) {
			if ((addr & 0x3FF) != 0 || (addr & 0xF0000000L) != 0) {
				message = ResourceProvider.getResourceString("msg.vec.addr.bit.std");
			}
		} else {
			if ((addr & 0x3FF) != 0) {
				message = ResourceProvider.getResourceString("msg.vec.addr.bit");
			}
		}
		
	}

	public String getMessage() {
		return message;
	}

}
