/*
 * Created on 2008/02/14
 */
package jp.co.epson.ide.eclipse.gnu33.others;

import jp.co.epson.ide.eclipse.gnu33.Gnu33CorePlugin;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

/**
 * Log delegate for GnuXXCorePlugin.<br>
 * 
 * In favor of reducing dependencies to the Plugin class
 * for logging. 
 * @author D.Fujimoto
 *
 */
public class Logger {

	
	/**
	 * For logging.
	 * Will be written to the platform log file.
	 * @param status
	 */
	public static void log(IStatus status) {
		Gnu33CorePlugin.getDefault().getLog().log(status);
	}

	/**
	 * For logging.
	 * Will be written to the platform log file.
	 * @param message
	 */
	public static void log(String message) {
		log(new Status(IStatus.ERROR, Gnu33CorePlugin.getUniqueIdentifier(), IStatus.ERROR,
				message, null));
	}

	/**
	 * For logging.
	 * Will be written to the platform log file.
	 * @param th
	 */
	public static void log(Throwable th) {
		log(new Status(IStatus.ERROR, Gnu33CorePlugin.getUniqueIdentifier(), IStatus.ERROR,
				"Internal Error!", th)); //$NON-NLS-1$
	}
	
}
