/*
 * 쐬: 2006/02/20
 *
 */
package jp.co.epson.ide.eclipse.gnu33.variables;

import jp.co.epson.ide.eclipse.gnu33.Gnu33CorePlugin;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.variables.IDynamicVariable;
import org.eclipse.core.variables.IDynamicVariableResolver;

/**
 * Resolves the variable "gnu33_loc".
 * 
 * @author D.Fujimoto
 * @since 1.3.0
 */
public class ToolPathVarResolver implements IDynamicVariableResolver {

	// dynamic variable name(see dynamicVariables extension)
	public static final String TOOL_LOC = "gnu33_loc"; //$NON-NLS-1$
	
	/* ( Javadoc)
	 * @see org.eclipse.core.variables.IDynamicVariableResolver#resolveValue(org.eclipse.core.variables.IDynamicVariable, java.lang.String)
	 */
	public String resolveValue(IDynamicVariable variable, String argument)
			throws CoreException {

		// set the file system path to the tools directory
		return Gnu33CorePlugin.getGnuToolsPath().toString();
	}

	
	/**
	 * Returns an IPath(Absolute path) to the GNUxx Tools' directory.
	 * @return	path tools' directory
	 * @since 1.4.1	for reducing dependencies
	 */
	public static IPath getGnuToolsPath() {
		return Gnu33CorePlugin.getGnuToolsPath();
	}

}
