/*
 * 쐬: 2005/11/02
 *
 */
package jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os;

import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.OSMonitorPlugin;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.core.runtime.IExtensionRegistry;
import org.eclipse.core.runtime.Platform;

/**
 * Factory for creating the IOSMonitorController with
 * the accepted OS name.
 * @author D.Fujimoto
 *
 */
public class ControllerFactory {

	/**
	 * Creates the controller.
	 * 
	 * @param osName			the retreived OS name
	 * @return may return null
	 */
	public static IOSMonitorController createController(String osName) {
		
		IExtensionRegistry reg = Platform.getExtensionRegistry();
		IExtensionPoint point = reg.getExtensionPoint(OSMonitorPlugin.PLUGIN_ID + ".controller"); // extension id //$NON-NLS-1$
		IExtension[] exts = point.getExtensions();
		for (int i = 0; i < exts.length; i++) {
			IConfigurationElement[] ele = exts[i].getConfigurationElements();
			for (int j = 0; j < ele.length; j++) {
				if (ele[j].getName().equals("controller")) {	 // tag			//$NON-NLS-1$
					String name = ele[j].getAttribute("osname"); // attribute	//$NON-NLS-1$
					
					if (osName.equals(name)) {
						try {
							return (IOSMonitorController) ele[j].createExecutableExtension("class");
						} catch (CoreException e) {
							e.printStackTrace();
						}
					}
				}
			}
		}
		
		return null;
		
	}
	
}
