/*
 * 쐬: 2005/12/06
 *
 */
package jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.command;

import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.ToppersMonitorController;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.IToppersMonitorInput;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.TaskData;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.input.data.TaskManagementData;

/**
 * 
 * Command that reads the tasks management data and the tasks data. 
 * 
 * @author D.Fujimoto
 *
 */
public class GetBaseCommand extends MonitorCommand {

	
	/**
	 * Constructor.<br>
	 * Requires the controller for proper operation.
	 */
	public GetBaseCommand(ToppersMonitorController controller) {
		this.controller = controller;
	}
	
	/* ( Javadoc)
	 * @see jp.co.epson.ide.eclipse.gnu33.osmonitor.core.os.tps.command.MonitorCommand#executeCommand()
	 */
	public void executeCommand() {
		
		// read data
		controller.getMngData();
		controller.getTaskData();
		
		IToppersMonitorInput input = (IToppersMonitorInput) controller.getMonitorInput();
		
		// additional ops for the manage data 
		// set the index for running/ready tasks
		TaskManagementData mng = input.getTaskManagementData();
		TaskData[] tasks = input.getTaskData();
		
		int runIdx = controller.getTaskIdFromAddress(mng.getRunningTaskAddress(), tasks);
		mng.setRunTaskIndex(runIdx);
	
		int rdyIdx = controller.getTaskIdFromAddress(mng.getReadyTaskAddress(), tasks);
		mng.setReadyTaskIndex(rdyIdx);
		
	}

}
