/*
 * 쐬: 2005/10/19
 *
 */
package jp.co.epson.ide.eclipse.gnu33.osmonitor.core.pref;

import jp.co.epson.ide.eclipse.gnu33.osmonitor.core.OSMonitorPlugin;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;


/**
 * This class sets the defaults to the Preference Store.
 * 
 * These settings can be overridden in the plugin_customization.ini file by specifying
 * PLUGIN_ID/KEY=VALUE.
 * @author D.Fujimoto
 *
 */
public class OSMonitorPreferenceInitializer extends
		AbstractPreferenceInitializer {

	/* ( Javadoc)
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = OSMonitorPlugin.getDefault().getPreferenceStore();
		
		// library name(dll)
		store.setDefault("connection.libName", "gnu33ide.dll");
		
		// connection timeout
		store.setDefault("connection.timeout", 5000);
		
		// retry interval in OSMonitorConnection
		store.setDefault("retry.interval", 50);

	}

}
