/*
 * 쐬: 2005/06/15
 *
 */
package jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views;

import jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views.content.CyclicHandlerMonitorContent;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views.content.DataQueueMonitorContent;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views.content.EventFlagMonitorContent;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views.content.FixedMemoryPoolMonitorContent;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views.content.IMonitorViewContent;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views.content.MailBoxMonitorContent;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views.content.ReadyQueueMonitorContent;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views.content.SemaphoreMonitorContent;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views.content.TaskManagementMonitorContent;
import jp.co.epson.ide.eclipse.gnu33.osmonitor.ui.views.content.TaskMonitorContent;

import org.eclipse.swt.widgets.Composite;



/**
 * Factory class that creates the tab items for the view.
 * 
 * @author D.Fujimoto
 *
 */
public class ToppersMonitorViewerFactory {

	/**
	 * Creates the contents(TableViewer) for the monotor view
	 * @param parent	parent composite
	 * @return			IMonitorViewContent[]
	 */
	public static IMonitorViewContent[] createToppersMonitorContents(Composite parent) {
	
		// supply the contents (with property file key and column count)
		IMonitorViewContent[] contents = {
				new TaskManagementMonitorContent("tps.tskmng", 2), 		//$NON-NLS-1$
				new TaskMonitorContent("tps.tskcontrol", 12), 			//$NON-NLS-1$
				new ReadyQueueMonitorContent("tps.rdyqueue", 2), 		//$NON-NLS-1$
				new CyclicHandlerMonitorContent("tps.cychandler", 8), 	//$NON-NLS-1$
				new MailBoxMonitorContent("tps.mailbox", 5), 			//$NON-NLS-1$
				new SemaphoreMonitorContent("tps.semaphore", 5), 		//$NON-NLS-1$
				new EventFlagMonitorContent("tps.eventflg", 6), 		//$NON-NLS-1$
				new DataQueueMonitorContent("tps.dataqueue", 7), 		//$NON-NLS-1$
				new FixedMemoryPoolMonitorContent("tps.fmempool", 8) 	//$NON-NLS-1$
		};
		
		// create TableViewer
		for (int i = 0; i < contents.length; i++) {
			contents[i].createTableViewer(parent);
		}
		
		return contents;
	
	}
	
}
